use std::time::{Instant};

use color_eyre::eyre;

mod lib;
use lib::load;
mod day4;


fn main() -> eyre::Result<()> {
    let data = load("data/04.txt")?;
    let start = Instant::now();
    day4::run(&data)?;
    let (dur, unit) = format_ns(start.elapsed().as_nanos());
    println!("Completed in {}{}", dur, unit);
    Ok(())
}


fn format_ns(ns: u128) -> (u128, &'static str) {
    const UNITS: [&str; 4] = ["ns", "us", "ms", "s"];
    let mut display_n = ns;
    let mut unit_idx = 0;
    while display_n > 1000 && unit_idx < 4 {
        display_n /= 1000;
        unit_idx += 1
    }

    (display_n, UNITS[unit_idx])
}
